#if TURBO
class Vendor
{
    string skyPath;

    CScene3d@ scene;
    CSceneMobil@ city;
    CSceneCloudSystem@ clouds;
    array<CSceneMobil@> decoration;
}

class Mania : Game
{
    void FullSkyDomeToggle(bool enabled)
    {        
        if (enabled) {
            CSystemFidFile@ fidSkyFull = Fids::GetGame(skyPath + "SkyDomeDouble.Solid.Gbx");
            CPlugSolid@ skyFull = cast<CPlugSolid>(fidSkyFull.Preload());
            @skydome.Solid = skyFull;
        } else {
            CSystemFidFile@ fidSkyHalf = Fids::GetGame(skyPath + "SkyDome.Solid.Gbx");
            CPlugSolid@ skyHalf = cast<CPlugSolid>(fidSkyHalf.Preload());
            @skydome.Solid = skyHalf;
        }
    }

    void AddVendorNods() override
    {
        string environment = app.Challenge.CollectionName;
        @scene = app.GameScene.Scene;
        @camera = cast<CHmsCamera>(app.GameCamera.SceneCamera.HmsPoc);
        @clouds = cast<CSceneCloudSystem>(scene.MgrWeather.CloudSystem);

        for (uint i = 0; i < scene.Mobils.Length; i++) {
            auto mobil = scene.Mobils[i];
            if (environment == "Stadium") {
                if (i == 4) {
                    decoration.InsertLast(mobil);
                }
                if (mobil.IdName == "Flags") {
                    decoration.InsertLast(mobil);
                }
                if (mobil.IdName == "SkyDome") {
                    @skydome = mobil;
                }
            } else if (environment == "Valley" || environment == "Lagoon") {
                if (i == 1) {
                    @skydome = mobil;
                }
            } else {
                if (i == 0) {
                    @skydome = mobil;
                }
            }
            if (mobil.IdName == "Warp") {
                decoration.InsertLast(mobil);
            }
        }
        InitNods();
    }

    void RemoveVendorNods() override
    {
        @scene = null;
        @city = null;
        decoration.RemoveRange(0, decoration.Length);
    }

    void ApplyVendorSettings() override
    {
        if (initialised) {
            if (camera !is null) {
                camera.ZClipEnable = Setting_ZClip;
                camera.ZClipValue = Setting_ZClipDistance;
                camera.ClearColor = Setting_BackgroundColor;
                camera.ClearColorEnable = !Setting_Background;
                if (Setting_ZClip) {
                    camera.ZClipZBuffer1End = 1.f;
                    camera.ZClipZBuffer2Start = 0;
                }
            }
            if (clouds !is null) {
                clouds.IsVisible = Setting_Clouds;
                clouds.MaterialUseT3b = Setting_CloudsLighting;
            }
            for (uint i = 0; i < decoration.Length; i++) {
                auto item = decoration[i];
                if (item !is null) {
                    decoration[i].IsVisible = Setting_Decoration;
                }
            }
        }
    }
}
#endif