class EnvironmentTab : Tab {
    string GetLabel() override { return Icons::Tree + " Environment"; }

    void Render() override
    {
        // Clear Color
		Setting_BackgroundColor = UI::InputColor3("Background", Setting_BackgroundColor);

		UI::Separator();

#if !TMNEXT
		// Background
		Setting_Decoration = UI::Checkbox("Decoration Toggle", Setting_Decoration);

		if (UI::IsItemHovered()) {
			UI::BeginTooltip();
			UI::Text("Toggle decoration");
			UI::EndTooltip();
		}
#endif

		Setting_Background = UI::Checkbox("Skydome Toggle", Setting_Background);

		if (UI::IsItemHovered()) {
			UI::BeginTooltip();
			UI::Text("Toggle background skydome");
			UI::EndTooltip();
		}

#if !TMNEXT
		UI::SameLine();
		Setting_BackgroundDouble = UI::Checkbox("Full Skydome", Setting_BackgroundDouble);

		UI::SameLine();
		if (UI::Button("Apply"))
			game.FullSkyDomeToggle(Setting_BackgroundDouble);

		if (UI::IsItemHovered()) {
			UI::BeginTooltip();
			UI::Text("Use double-sided skydome in environments other than Stadium");
			UI::EndTooltip();
		}

		// Clouds
        Setting_Clouds = UI::Checkbox("Clouds Toggle", Setting_Clouds);

		if (UI::IsItemHovered()) {
			UI::BeginTooltip();
			UI::Text("Toggle clouds");
			UI::EndTooltip();
		}

        UI::SameLine();

        if (!Setting_Clouds) UI::BeginDisabled();
		Setting_CloudsLighting = UI::Checkbox("Clouds Lighting", Setting_CloudsLighting);
		if (UI::IsItemHovered()) {
			UI::BeginTooltip();
			UI::Text("Should lighting affects clouds");
			UI::EndTooltip();
		}
        if (!Setting_Clouds) UI::EndDisabled();
#endif
    }
}