class InterfaceTab : Tab {
    string GetLabel() override { return Icons::WindowMaximize + " Interface"; }

    void Render() override
    {
#if TMNEXT
        // Overlay Scaling

		if (UI::BeginCombo("Overlay Scaling", tostring(Setting_OverlayScaling).Replace("_", " "))) {
			for (int i = -1; i < 10; i++) {
				if (tostring(OverlayScaling(i)) == tostring(i)) continue; // thanks to NaNInf
				if (UI::Selectable(tostring(OverlayScaling(i)).Replace("_", " "), false)) {
					Setting_OverlayScaling = OverlayScaling(i);
				}
			}
			UI::EndCombo();
		}

        if (UI::IsItemHovered()) {
			UI::BeginTooltip();
			UI::Text("\\$ff0Preview Version Note");
			UI::Text("To revert to default setting, choose \"Default\" option and restart the scene.");
			UI::Text("(e.g. if you're in the editor, go back to the menu and open the editor again)");
			UI::EndTooltip();
		}

        Setting_OverlayScalingFastUpdate = UI::Checkbox("Faster Update", Setting_OverlayScalingFastUpdate);

        if (UI::IsItemHovered()) {
			UI::BeginTooltip();
			UI::Text("Updates scaling immediately but may reduce performance.");
			UI::EndTooltip();
		}

        UI::Separator();
#endif

        // FPS Counter

        Setting_FPS = UI::Checkbox("FPS Counter", Setting_FPS);

		if (UI::IsItemHovered()) {
			UI::BeginTooltip();
			UI::Text("Toggle simple FPS counter");
			UI::EndTooltip();
		}
    }
}